/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TikTokStaticDtoAuthorizer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TikTokStaticDtoAuthorizer{}

// TikTokStaticDtoAuthorizer struct for TikTokStaticDtoAuthorizer
type TikTokStaticDtoAuthorizer struct {
	StaticKey    *string `json:"staticKey,omitempty"`
	Label        *string `json:"label,omitempty"`
	ClientId     *string `json:"clientId,omitempty"`
	ClientSecret *string `json:"clientSecret,omitempty"`
	RedirectUri  *string `json:"redirectUri,omitempty"`
}

// NewTikTokStaticDtoAuthorizer instantiates a new TikTokStaticDtoAuthorizer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTikTokStaticDtoAuthorizer() *TikTokStaticDtoAuthorizer {
	this := TikTokStaticDtoAuthorizer{}
	return &this
}

// NewTikTokStaticDtoAuthorizerWithDefaults instantiates a new TikTokStaticDtoAuthorizer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTikTokStaticDtoAuthorizerWithDefaults() *TikTokStaticDtoAuthorizer {
	this := TikTokStaticDtoAuthorizer{}
	return &this
}

// GetStaticKey returns the StaticKey field value if set, zero value otherwise.
func (o *TikTokStaticDtoAuthorizer) GetStaticKey() string {
	if o == nil || IsNil(o.StaticKey) {
		var ret string
		return ret
	}
	return *o.StaticKey
}

// GetStaticKeyOk returns a tuple with the StaticKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokStaticDtoAuthorizer) GetStaticKeyOk() (*string, bool) {
	if o == nil || IsNil(o.StaticKey) {
		return nil, false
	}
	return o.StaticKey, true
}

// HasStaticKey returns a boolean if a field has been set.
func (o *TikTokStaticDtoAuthorizer) HasStaticKey() bool {
	if o != nil && !IsNil(o.StaticKey) {
		return true
	}

	return false
}

// SetStaticKey gets a reference to the given string and assigns it to the StaticKey field.
func (o *TikTokStaticDtoAuthorizer) SetStaticKey(v string) {
	o.StaticKey = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *TikTokStaticDtoAuthorizer) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokStaticDtoAuthorizer) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *TikTokStaticDtoAuthorizer) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *TikTokStaticDtoAuthorizer) SetLabel(v string) {
	o.Label = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *TikTokStaticDtoAuthorizer) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokStaticDtoAuthorizer) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *TikTokStaticDtoAuthorizer) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *TikTokStaticDtoAuthorizer) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *TikTokStaticDtoAuthorizer) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokStaticDtoAuthorizer) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *TikTokStaticDtoAuthorizer) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *TikTokStaticDtoAuthorizer) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *TikTokStaticDtoAuthorizer) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokStaticDtoAuthorizer) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *TikTokStaticDtoAuthorizer) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *TikTokStaticDtoAuthorizer) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

func (o TikTokStaticDtoAuthorizer) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TikTokStaticDtoAuthorizer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.StaticKey) {
		toSerialize["staticKey"] = o.StaticKey
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	return toSerialize, nil
}

type NullableTikTokStaticDtoAuthorizer struct {
	value *TikTokStaticDtoAuthorizer
	isSet bool
}

func (v NullableTikTokStaticDtoAuthorizer) Get() *TikTokStaticDtoAuthorizer {
	return v.value
}

func (v *NullableTikTokStaticDtoAuthorizer) Set(val *TikTokStaticDtoAuthorizer) {
	v.value = val
	v.isSet = true
}

func (v NullableTikTokStaticDtoAuthorizer) IsSet() bool {
	return v.isSet
}

func (v *NullableTikTokStaticDtoAuthorizer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTikTokStaticDtoAuthorizer(val *TikTokStaticDtoAuthorizer) *NullableTikTokStaticDtoAuthorizer {
	return &NullableTikTokStaticDtoAuthorizer{value: val, isSet: true}
}

func (v NullableTikTokStaticDtoAuthorizer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTikTokStaticDtoAuthorizer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
